]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
Fix toolchain download
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.3"
28 GIT_BRANCH=master:master # Version number
29 SLOGAN="www.ipfire.org" # Software slogan
30 CONFIG_ROOT=/var/ipfire # Configuration rootdir
31 NICE=10 # Nice level
32 MAX_RETRIES=1 # prefetch/check loop
33 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
34 MACHINE=`uname -m`
35 GIT_TAG=$(git tag | tail -1)
36
37 IPFVER="full" # Which versions should be compiled? (full|devel)
38
39 # Debian specific settings
40 if [ ! -e /etc/debian_version ]; then
41 FULLPATH=`which $0`
42 else
43 if [ -x /usr/bin/realpath ]; then
44 FULLPATH=`/usr/bin/realpath $0`
45 else
46 echo "ERROR: Need to do apt-get install realpath"
47 exit 1
48 fi
49 fi
50
51 PWD=`pwd`
52 BASENAME=`basename $0`
53 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
54 LOGFILE=$BASEDIR/log/_build.preparation.log
55 export BASEDIR LOGFILE
56 DIR_CHK=$BASEDIR/cache/check
57 mkdir $BASEDIR/log/ 2>/dev/null
58
59 # Include funtions
60 . tools/make-functions
61
62 if [ -f .config ]; then
63 . .config
64 else
65 echo -e "${BOLD}No configuration found!${NORMAL}"
66 echo -ne "Do you want to create one (y/N)?"
67 read CREATE_CONFIG
68 echo ""
69 if [ "$CREATE_CONFIG" == "y" ]; then
70 make_config
71 fi
72 fi
73
74 if [ -z $EDITOR ]; then
75 for i in nano emacs vi; do
76 EDITOR=$(which $i 2>/dev/null)
77 if ! [ -z $EDITOR ]; then
78 export EDITOR=$EDITOR
79 break
80 fi
81 done
82 [ -z $EDITOR ] && exiterror "You should have installed an editor."
83 fi
84
85 prepareenv() {
86 ############################################################################
87 # #
88 # Are we running the right shell? #
89 # #
90 ############################################################################
91 if [ ! "$BASH" ]; then
92 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
93 fi
94
95 if [ -z "${BASH_VERSION}" ]; then
96 exiterror "Not running BASH shell."
97 fi
98
99
100 ############################################################################
101 # #
102 # Trap on emergency exit #
103 # #
104 ############################################################################
105 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
106
107
108 ############################################################################
109 # #
110 # Resetting our nice level #
111 # #
112 ############################################################################
113 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
114 renice $NICE $$ > /dev/null
115 if [ `nice` != "$NICE" ]; then
116 beautify message FAIL
117 exiterror "Failed to set correct nice level"
118 else
119 beautify message DONE
120 fi
121
122
123 ############################################################################
124 # #
125 # Checking if running as root user #
126 # #
127 ############################################################################
128 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
129 if [ `id -u` != 0 ]; then
130 beautify message FAIL
131 exiterror "Not building as root"
132 else
133 beautify message DONE
134 fi
135
136
137 ############################################################################
138 # #
139 # Checking for necessary temporary space #
140 # #
141 ############################################################################
142 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
143 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
144 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
145 if (( 2048000 > $BASE_ASPACE )); then
146 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
147 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
148 beautify message FAIL
149 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
150 fi
151 else
152 beautify message DONE
153 fi
154
155 ############################################################################
156 # #
157 # Building Linux From Scratch system #
158 # #
159 ############################################################################
160 # Set umask
161 umask 022
162
163 # Set LFS Directory
164 LFS=$BASEDIR/build
165
166 # Check /tools symlink
167 if [ -h /tools ]; then
168 rm -f /tools
169 fi
170 if [ ! -a /tools ]; then
171 ln -s $BASEDIR/build/tools /
172 fi
173 if [ ! -h /tools ]; then
174 exiterror "Could not create /tools symbolic link."
175 fi
176
177 # Setup environment
178 set +h
179 LC_ALL=POSIX
180 if [ -z $MAKETUNING ]; then
181 MAKETUNING="-j6"
182 fi
183 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
184 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
185
186 # Make some extra directories
187 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
188 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
189 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
190 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
191
192 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
193 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
194
195 # Make all sources and proc available under lfs build
196 mount --bind /dev $BASEDIR/build/dev
197 mount --bind /dev/pts $BASEDIR/build/dev/pts
198 mount --bind /dev/shm $BASEDIR/build/dev/shm
199 mount --bind /proc $BASEDIR/build/proc
200 mount --bind /sys $BASEDIR/build/sys
201 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
202 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
203 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
204 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
205 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
206 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
207 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
208 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
209 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
210
211 # This is a temporary hack!!!
212 if [ ! -f /tools/bin/hostname ]; then
213 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
214 fi
215
216 # Run LFS static binary creation scripts one by one
217 export CCACHE_DIR=$BASEDIR/ccache
218 export CCACHE_HASHDIR=1
219
220 # Remove pre-install list of installed files in case user erase some files before rebuild
221 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
222 }
223
224 buildtoolchain() {
225 LOGFILE="$BASEDIR/log/_build.toolchain.log"
226 export LOGFILE
227 ORG_PATH=$PATH
228 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
229 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
230 lfsmake1 ccache
231 lfsmake1 binutils PASS=1
232 lfsmake1 gcc PASS=1
233 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
234 lfsmake1 linux-libc-header
235 lfsmake1 glibc
236 lfsmake1 cleanup-toolchain PASS=1
237 lfsmake1 tcl
238 lfsmake1 expect
239 lfsmake1 dejagnu
240 lfsmake1 gcc PASS=2
241 lfsmake1 binutils PASS=2
242 lfsmake1 ncurses
243 lfsmake1 bash
244 lfsmake1 bzip2
245 lfsmake1 coreutils
246 lfsmake1 diffutils
247 lfsmake1 findutils
248 lfsmake1 gawk
249 lfsmake1 gettext
250 lfsmake1 grep
251 lfsmake1 gzip
252 lfsmake1 m4
253 lfsmake1 make
254 lfsmake1 patch
255 lfsmake1 perl
256 lfsmake1 sed
257 lfsmake1 tar
258 lfsmake1 texinfo
259 lfsmake1 util-linux
260 lfsmake1 cleanup-toolchain PASS=2
261 export PATH=$ORG_PATH
262 }
263
264 buildbase() {
265 LOGFILE="$BASEDIR/log/_build.base.log"
266 export LOGFILE
267 lfsmake2 stage2
268 lfsmake2 linux-libc-header
269 lfsmake2 man-pages
270 lfsmake2 glibc
271 lfsmake2 cleanup-toolchain PASS=3
272 lfsmake2 binutils
273 lfsmake2 gcc
274 lfsmake2 berkeley
275 lfsmake2 coreutils
276 lfsmake2 iana-etc
277 lfsmake2 m4
278 lfsmake2 bison
279 lfsmake2 ncurses
280 lfsmake2 procps
281 lfsmake2 sed
282 lfsmake2 libtool
283 lfsmake2 perl
284 lfsmake2 readline
285 lfsmake2 zlib
286 lfsmake2 autoconf
287 lfsmake2 automake
288 lfsmake2 bash
289 lfsmake2 bzip2
290 lfsmake2 diffutils
291 lfsmake2 e2fsprogs
292 lfsmake2 ed
293 lfsmake2 file
294 lfsmake2 findutils
295 lfsmake2 flex
296 lfsmake2 gawk
297 lfsmake2 gettext
298 lfsmake2 grep
299 lfsmake2 groff
300 lfsmake2 gzip
301 lfsmake2 inetutils
302 lfsmake2 iproute2
303 lfsmake2 kbd
304 lfsmake2 less
305 lfsmake2 libaal
306 lfsmake2 make
307 lfsmake2 man
308 lfsmake2 mktemp
309 lfsmake2 module-init-tools
310 lfsmake2 mtd
311 lfsmake2 net-tools
312 lfsmake2 patch
313 lfsmake2 psmisc
314 lfsmake2 reiser4progs
315 lfsmake2 shadow
316 lfsmake2 sysklogd
317 lfsmake2 sysvinit
318 lfsmake2 tar
319 lfsmake2 texinfo
320 lfsmake2 udev
321 lfsmake2 util-linux
322 lfsmake2 vim
323 lfsmake2 grub
324 }
325
326 buildipfire() {
327 LOGFILE="$BASEDIR/log/_build.ipfire.log"
328 export LOGFILE
329 ipfiremake configroot
330 ipfiremake backup
331 ipfiremake dhcp
332 ipfiremake dhcpcd
333 ipfiremake libusb
334 ipfiremake libpcap
335 ipfiremake ppp
336 ipfiremake rp-pppoe
337 ipfiremake pptp
338 ipfiremake unzip
339 ipfiremake linux
340 ipfiremake atl2
341 ipfiremake kqemu
342 ipfiremake v4l-dvb
343 ipfiremake madwifi
344 ipfiremake alsa KMOD=1
345 ipfiremake openswan KMOD=1
346 ipfiremake pkg-config
347 ipfiremake linux-atm
348 ipfiremake cpio
349 ipfiremake klibc
350 ipfiremake mkinitcpio
351 ipfiremake udev KLIBC=1
352 ipfiremake expat
353 ipfiremake gdbm
354 ipfiremake gmp
355 ipfiremake pam
356 ipfiremake openssl
357 ipfiremake curl
358 ipfiremake python
359 ipfiremake libnet
360 ipfiremake libidn
361 ipfiremake libjpeg
362 ipfiremake libpng
363 ipfiremake libtiff
364 ipfiremake libart
365 ipfiremake freetype
366 ipfiremake gd
367 ipfiremake popt
368 ipfiremake pcre
369 ipfiremake slang
370 ipfiremake newt
371 ipfiremake libcap
372 ipfiremake pciutils
373 ipfiremake usbutils
374 ipfiremake libxml2
375 ipfiremake libxslt
376 ipfiremake BerkeleyDB
377 ipfiremake mysql
378 ipfiremake cyrus-sasl
379 ipfiremake openldap
380 ipfiremake apache2
381 ipfiremake php
382 ipfiremake apache2 PASS=C
383 ipfiremake arping
384 ipfiremake beep
385 ipfiremake bind
386 ipfiremake cdrtools
387 ipfiremake dnsmasq
388 ipfiremake dosfstools
389 ipfiremake squashfstools
390 ipfiremake reiserfsprogs
391 ipfiremake xfsprogs
392 ipfiremake sysfsutils
393 ipfiremake fuse
394 ipfiremake ntfs-3g
395 ipfiremake ethtool
396 ipfiremake ez-ipupdate
397 ipfiremake fcron
398 ipfiremake perl-GD
399 ipfiremake GD-Graph
400 ipfiremake GD-TextUtil
401 ipfiremake gnupg
402 ipfiremake hdparm
403 ipfiremake sdparm
404 ipfiremake mtools
405 ipfiremake initscripts
406 ipfiremake whatmask
407 ipfiremake iptables
408 ipfiremake libupnp
409 ipfiremake ipaddr
410 ipfiremake iptstate
411 ipfiremake iputils
412 ipfiremake l7-protocols
413 ipfiremake mISDN
414 ipfiremake capi4k-utils
415 ipfiremake hwdata
416 ipfiremake kudzu
417 ipfiremake logrotate
418 ipfiremake logwatch
419 ipfiremake misc-progs
420 ipfiremake nano
421 ipfiremake nasm
422 ipfiremake URI
423 ipfiremake HTML-Tagset
424 ipfiremake HTML-Parser
425 ipfiremake Compress-Zlib
426 ipfiremake Digest
427 ipfiremake Digest-SHA1
428 ipfiremake Digest-HMAC
429 ipfiremake libwww-perl
430 ipfiremake Net-DNS
431 ipfiremake Net-IPv4Addr
432 ipfiremake Net_SSLeay
433 ipfiremake IO-Stringy
434 ipfiremake Unix-Syslog
435 ipfiremake Mail-Tools
436 ipfiremake MIME-Tools
437 ipfiremake Net-Server
438 ipfiremake Convert-TNEF
439 ipfiremake Convert-UUlib
440 ipfiremake Archive-Tar
441 ipfiremake Archive-Zip
442 ipfiremake Text-Tabs+Wrap
443 ipfiremake Locale-Country
444 ipfiremake XML-Parser
445 ipfiremake python-setuptools
446 ipfiremake python-clientform
447 ipfiremake python-mechanize
448 ipfiremake python-feedparser
449 ipfiremake python-rssdler
450 ipfiremake glib
451 ipfiremake GeoIP
452 ipfiremake fwhits
453 ipfiremake noip_updater
454 ipfiremake ntp
455 ipfiremake openssh
456 ipfiremake rrdtool
457 ipfiremake setserial
458 ipfiremake setup
459 ipfiremake snort
460 ipfiremake oinkmaster
461 ipfiremake squid
462 ipfiremake squidguard
463 ipfiremake calamaris
464 ipfiremake tcpdump
465 ipfiremake traceroute
466 ipfiremake vlan
467 ipfiremake wireless
468 ipfiremake libsafe
469 ipfiremake pakfire
470 ipfiremake java
471 ipfiremake spandsp
472 ipfiremake lzo
473 ipfiremake openvpn
474 ipfiremake pammysql
475 ipfiremake cups
476 ipfiremake ghostscript
477 ipfiremake foomatic
478 ipfiremake hplip
479 ipfiremake samba
480 ipfiremake sudo
481 ipfiremake mc
482 ipfiremake wget
483 ipfiremake bridge-utils
484 ipfiremake screen
485 ipfiremake hddtemp
486 ipfiremake smartmontools
487 ipfiremake htop
488 ipfiremake postfix
489 ipfiremake fetchmail
490 ipfiremake cyrus-imapd
491 ipfiremake openmailadmin
492 ipfiremake clamav
493 ipfiremake spamassassin
494 ipfiremake amavisd
495 ipfiremake alsa
496 ipfiremake mpfire
497 ipfiremake guardian
498 ipfiremake libid3tag
499 ipfiremake libmad
500 ipfiremake libogg
501 ipfiremake libvorbis
502 ipfiremake libdvbpsi
503 ipfiremake lame
504 ipfiremake sox
505 ipfiremake libshout
506 ipfiremake icecast
507 ipfiremake icegenerator
508 ipfiremake mpd
509 ipfiremake mpc
510 ipfiremake xvid
511 ipfiremake libmpeg2
512 ipfiremake cmake
513 ipfiremake libpri
514 ipfiremake asterisk
515 ipfiremake gnump3d
516 ipfiremake libsigc++
517 ipfiremake applejuice
518 ipfiremake ocaml
519 ipfiremake mldonkey
520 ipfiremake libtorrent
521 ipfiremake rtorrent
522 ipfiremake ipfireseeder
523 ipfiremake rsync
524 ipfiremake tcpwrapper
525 ipfiremake portmap
526 ipfiremake nfs
527 ipfiremake nmap
528 ipfiremake ncftp
529 ipfiremake etherwake
530 ipfiremake bwm-ng
531 ipfiremake tripwire
532 ipfiremake sysstat
533 ipfiremake vsftpd
534 ipfiremake which
535 ipfiremake openswan
536 ipfiremake lsof
537 ipfiremake centerim
538 ipfiremake br2684ctl
539 ipfiremake pcmciautils
540 ipfiremake lm_sensors
541 ipfiremake collectd
542 ipfiremake lcd4linux
543 ipfiremake tcptrack
544 ipfiremake teamspeak
545 ipfiremake elinks
546 ipfiremake igmpproxy
547 ipfiremake fbset
548 ipfiremake sdl
549 ipfiremake qemu
550 ipfiremake sane
551 ipfiremake netpbm
552 ipfiremake phpSANE
553 ipfiremake tunctl
554 ipfiremake nagios
555 ipfiremake ebtables
556 ipfiremake fontconfig
557 ipfiremake freefont
558 ipfiremake directfb
559 ipfiremake dfb++
560 ipfiremake ffmpeg
561 ipfiremake videolan
562 ipfiremake vdr
563 ipfiremake w_scan
564 ipfiremake git
565 ipfiremake squidclamav
566 ipfiremake bc
567 ipfiremake esniper
568 ipfiremake vnstat
569 ipfiremake vnstati
570 ipfiremake wpa_supplicant
571 ipfiremake hostapd
572 ipfiremake urlgrabber
573 ipfiremake syslinux
574 ipfiremake tftp-hpa
575 ipfiremake cpufrequtils
576 ipfiremake dbus
577 ipfiremake bluetooth
578 ipfiremake gutenprint
579 ipfiremake apcupsd
580 ipfiremake iperf
581 ipfiremake netcat
582 ipfiremake 7zip
583 ipfiremake lynis
584 ipfiremake cryptsetup
585 ipfiremake splix
586 ipfiremake streamripper
587 ipfiremake sshfs
588 ipfiremake libdlna
589 ipfiremake ushare
590 ipfiremake sqlite
591 ipfiremake taglib
592 ipfiremake mediatomb
593 ipfiremake sslh
594 echo Build on $HOSTNAME > $BASEDIR/build/var/ipfire/firebuild
595 cat /proc/version >> $BASEDIR/build/var/ipfire/firebuild
596 echo >> $BASEDIR/build/var/ipfire/firebuild
597 git log -1 >> $BASEDIR/build/var/ipfire/firebuild
598 echo >> $BASEDIR/build/var/ipfire/firebuild
599 git status >> $BASEDIR/build/var/ipfire/firebuild
600 echo >> $BASEDIR/build/var/ipfire/firebuild
601 cat /proc/cpuinfo >> $BASEDIR/build/var/ipfire/firebuild
602 }
603
604 buildinstaller() {
605 # Run installer scripts one by one
606 LOGFILE="$BASEDIR/log/_build.installer.log"
607 export LOGFILE
608 ipfiremake as86
609 ipfiremake mbr
610 ipfiremake memtest
611 installmake linux-libc-header
612 installmake binutils
613 ipfiremake uClibc PASS=1
614 ipfiremake gcc INST=1
615 installmake uClibc PASS=2
616 installmake gcc INST=2
617 installmake uClibc PASS=3
618 installmake busybox
619 installmake udev
620 installmake slang
621 installmake newt
622 installmake gettext
623 installmake kbd
624 installmake popt
625 installmake sysvinit
626 installmake misc-progs
627 installmake libaal
628 installmake reiser4progs
629 installmake reiserfsprogs
630 installmake sysfsutils
631 installmake util-linux
632 installmake pciutils
633 installmake zlib
634 installmake mtd
635 installmake wget
636 installmake hwdata
637 installmake kudzu
638 installmake pcmciautils
639 installmake installer
640 installmake initrd
641 }
642
643 buildpackages() {
644 LOGFILE="$BASEDIR/log/_build.packages.log"
645 export LOGFILE
646 echo "... see detailed log in _build.*.log files" >> $LOGFILE
647
648 installmake strip
649
650 # Generating list of packages used
651 echo -n "Generating packages list from logs" | tee -a $LOGFILE
652 rm -f $BASEDIR/doc/packages-list
653 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
654 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
655 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
656 fi
657 done
658 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
659 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
660 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
661 rm -f $BASEDIR/doc/packages-list
662 # packages-list.txt is ready to be displayed for wiki page
663 beautify message DONE
664
665 # Update changelog
666 cd $BASEDIR
667 $0 git log
668
669 # Create images for install
670 ipfiremake cdrom ED=$IPFVER
671
672 # Check if there is a loop device for building in virtual environments
673 if [ -e /dev/loop/0 ] || [ -e /dev/loop0 ]; then
674 ipfiremake usb-stick ED=$IPFVER
675 fi
676
677 # Create updater package
678 #ipfiremake updater
679 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
680
681 ipfirepackages
682
683 # Cleanup
684 stdumount
685 rm -rf $BASEDIR/build/tmp/*
686
687 # Generating total list of files
688 echo -n "Generating files list from logs" | tee -a $LOGFILE
689 rm -f $BASEDIR/log/FILES
690 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
691 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
692 echo "##" >>$BASEDIR/log/FILES
693 echo "## `basename $i`" >>$BASEDIR/log/FILES
694 echo "##" >>$BASEDIR/log/FILES
695 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
696 fi
697 done
698 beautify message DONE
699
700 cd $PWD
701 }
702
703 ipfirepackages() {
704 ipfiremake core-updates
705 for i in $(ls -1 $BASEDIR/config/rootfiles/packages); do
706 if [ -e $BASEDIR/lfs/$i ]; then
707 ipfiredist $i
708 else
709 echo -n $i
710 beautify message SKIP
711 fi
712 done
713 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
714 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
715 rm -rf $BASEDIR/build/install/packages/*
716 }
717
718 # See what we're supposed to do
719 case "$1" in
720 build)
721 clear
722 BUILDMACHINE=`uname -m`
723 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
724 #only restore on a clean disk
725 if [ ! -f log/cleanup-toolchain-2-tools ]; then
726 if [ ! -n "$PACKAGE" ]; then
727 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
728 prepareenv
729 buildtoolchain
730 else
731 PACKAGENAME=${PACKAGE%.tar.gz}
732 beautify build_stage "Packaged toolchain compilation"
733 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
734 tar zxf $PACKAGE
735 prepareenv
736 else
737 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
738 fi
739 fi
740 else
741 echo -n "Using installed toolchain" | tee -a $LOGFILE
742 beautify message SKIP
743 prepareenv
744 fi
745
746 beautify build_start
747 beautify build_stage "Building LFS"
748 buildbase
749
750 beautify build_stage "Building IPFire"
751 buildipfire
752
753 beautify build_stage "Building installer"
754 buildinstaller
755
756 beautify build_stage "Building packages"
757 buildpackages
758
759 beautify build_stage "Checking Logfiles for new Files"
760 cd ..
761 tools/checknewlog.pl
762
763 beautify build_end
764 ;;
765 shell)
766 # enter a shell inside LFS chroot
767 # may be used to changed kernel settings
768 prepareenv
769 entershell
770 ;;
771 clean)
772 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
773 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
774 $LOSETUP -d $i 2>/dev/null
775 done
776 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
777 umount $i
778 done
779 stdumount
780 for i in `seq 0 7`; do
781 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
782 umount /dev/loop${i} 2>/dev/null;
783 losetup -d /dev/loop${i} 2>/dev/null;
784 fi;
785 done
786 rm -rf $BASEDIR/build
787 rm -rf $BASEDIR/cdrom
788 rm -rf $BASEDIR/packages
789 rm -rf $BASEDIR/log
790 if [ -h /tools ]; then
791 rm -f /tools
792 fi
793 beautify message DONE
794 ;;
795 downloadsrc)
796 if [ ! -d $BASEDIR/cache ]; then
797 mkdir $BASEDIR/cache
798 fi
799 mkdir -p $BASEDIR/log
800 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
801 FINISHED=0
802 cd $BASEDIR/lfs
803 for c in `seq $MAX_RETRIES`; do
804 if (( FINISHED==1 )); then
805 break
806 fi
807 FINISHED=1
808 cd $BASEDIR/lfs
809 for i in *; do
810 if [ -f "$i" -a "$i" != "Config" ]; then
811 echo -ne "Loading $i"
812 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
813 if [ $? -ne 0 ]; then
814 beautify message FAIL
815 FINISHED=0
816 else
817 if [ $c -eq 1 ]; then
818 beautify message DONE
819 fi
820 fi
821 fi
822 done
823 done
824 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
825 ERROR=0
826 for i in *; do
827 if [ -f "$i" -a "$i" != "Config" ]; then
828 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
829 if [ $? -ne 0 ]; then
830 echo -ne "MD5 difference in lfs/$i"
831 beautify message FAIL
832 ERROR=1
833 fi
834 fi
835 done
836 if [ $ERROR -eq 0 ]; then
837 echo -ne "${BOLD}all files md5sum match${NORMAL}"
838 beautify message DONE
839 else
840 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
841 beautify message FAIL
842 fi
843 cd - >/dev/null 2>&1
844 ;;
845 toolchain)
846 clear
847 prepareenv
848 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
849 buildtoolchain
850 BUILDMACHINE=`uname -m`
851 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
852 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
853 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
854 build/{bin,etc,usr/bin,usr/local} \
855 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
856 log >> $LOGFILE
857 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
858 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
859 stdumount
860 ;;
861 gettoolchain)
862 BUILDMACHINE=`uname -m`
863 # arbitrary name to be updated in case of new toolchain package upload
864 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
865 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
866 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
867 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
868 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
869 cd $BASEDIR/cache/toolchains
870 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
871 if [ $? -ne 0 ]; then
872 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
873 else
874 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
875 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
876 else
877 exiterror "$PACKAGE.md5 did not match, check downloaded package"
878 fi
879 fi
880 else
881 echo "Toolchain is already downloaded. Exiting..."
882 fi
883 ;;
884 othersrc)
885 prepareenv
886 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
887 chroot $LFS /tools/bin/env -i HOME=/root \
888 TERM=$TERM PS1='\u:\w\$ ' \
889 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
890 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
891 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
892 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
893 if [ $? -eq "0" ]; then
894 beautify message DONE
895 else
896 beautify message FAIL
897 fi
898 stdumount
899 ;;
900 git)
901 case "$2" in
902 update|up)
903 ## REMOVES ALL UNCOMMITTED CHANGES!
904 [ "$3" == "--force" ] && git checkout -f
905 git pull
906 ;;
907 commit|ci)
908 shift 2
909 git commit $*
910
911 [ "$?" -eq "0" ] || exiterror "git commit $* failed."
912
913 echo -e "${BOLD}Do you want to push, too? [y/N]${NORMAL}"
914 read
915 [ -z $REPLY ] && exit 0
916 for i in y Y j J; do
917 if [ "$i" == "$REPLY" ]; then
918 $0 git push
919 exit $?
920 fi
921 done
922 exiterror "\"$REPLY\" is not a valid answer."
923 ;;
924 dist)
925 git archive HEAD | gzip -9 > ${SNAME}-${VERSION}.tar.gz
926 ;;
927 diff|di)
928 echo -ne "Make a local diff to last revision"
929 git diff HEAD > ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff
930 evaluate 1
931 echo "Diff was successfully saved to ipfire-diff-$(date +'%Y-%m-%d-%H:%M').diff"
932 git diff --stat
933 ;;
934 push)
935 [ -z $GIT_USER ] && exiterror "You have to setup GIT_USER first."
936 GIT_URL="ssh://${GIT_USER}@git.ipfire.org/pub/git/ipfire-2.x"
937
938 git push ${GIT_URL} ${GIT_BRANCH} $3
939 ;;
940 log)
941 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
942 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
943
944 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
945 ;;
946 esac
947 ;;
948 uploadsrc)
949 PWD=`pwd`
950 cd $BASEDIR/cache/
951 echo -e "Uploading cache to ftp server:"
952 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL/$FTP_CACHE_PATH/ > /tmp/ftplist
953 for i in *; do
954 if [ "$(basename $i)" == "toolchains" ]; then continue; fi
955 grep -q $(basename $i) /tmp/ftplist
956 if [ "$?" -ne "0" ]; then
957 echo -ne "$(basename $i)"
958 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $(basename $i)
959 if [ "$?" -ne "0" ]; then
960 beautify message FAIL
961 fi
962 fi
963 done
964 rm -f /tmp/ftplist
965 cd $PWD
966 exit 0
967 ;;
968 upload)
969 FTP_ISO_PORT=`echo "$FTP_ISO_URL" | awk -F: '{ print $2 }'`
970 FTP_ISO_URL=`echo "$FTP_ISO_URL" | awk -F: '{ print $1 }'`
971 if [ -z $FTP_ISO_PORT ]; then
972 FTP_ISO_PORT=21
973 fi
974 cat <<EOF > .ftp-commands
975 mkdir -p $FTP_ISO_PATH$SVN_REVISION
976 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
977 quit
978 EOF
979 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL < .ftp-commands
980 rm -f .ftp-commands
981
982 case "$2" in
983 iso)
984 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
985
986 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
987 for i in svn_status ipfire-source-r$SVN_REVISION.tar.gz ipfire-$VERSION.$MACHINE-full.iso ipfire-$VERSION.$MACHINE-full.iso.md5 ipfire-$VERSION.$MACHINE-devel.iso ipfire-$VERSION.$MACHINE-devel.iso.md5; do
988 if [ -e "$i" ]; then
989 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ $i
990 if [ "$?" -eq "0" ]; then
991 echo "The file with name $i was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
992 else
993 echo "There was an error while uploading the file $i to the ftp server."
994 exit 1
995 fi
996 fi
997 done
998 rm -f ipfire-$VERSION.$MACHINE-full.iso.md5
999 if [ "$3" = "--with-sources-cd" ]; then
1000 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
1001 fi
1002 ;;
1003 paks)
1004 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS -P $FTP_ISO_PORT $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1005 if [ "$?" -eq "0" ]; then
1006 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1007 else
1008 echo -e "There was an error while uploading the packages to the ftp server."
1009 exit 1
1010 fi
1011 ;;
1012 esac
1013 ;;
1014 batch)
1015 if [ "$2" = "--background" ]; then
1016 batch_script
1017 exit $?
1018 fi
1019 if [ `screen -ls | grep -q ipfire` ]; then
1020 echo "Build is already running, sorry!"
1021 exit 1
1022 else
1023 if [ "$2" = "--rebuild" ]; then
1024 export IPFIRE_REBUILD=1
1025 echo "REBUILD!"
1026 else
1027 export IPFIRE_REBUILD=0
1028 fi
1029 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1030 screen -dmS ipfire $0 batch --background
1031 evaluate 1
1032 exit 0
1033 fi
1034 ;;
1035 watch)
1036 watch_screen
1037 ;;
1038 pxe)
1039 case "$2" in
1040 start)
1041 start_tftpd
1042 ;;
1043 stop)
1044 stop_tftpd
1045 ;;
1046 reload|restart)
1047 reload_tftpd
1048 ;;
1049 esac
1050 exit 0
1051 ;;
1052 lang)
1053 update_langs
1054 ;;
1055 "")
1056 clear
1057 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "LOG: Tail" "Help"
1058 do
1059 case $name in
1060 "IPFIRE: Downloadsrc")
1061 $0 downloadsrc
1062 ;;
1063 "IPFIRE: Build (silent)")
1064 $0 build-silent
1065 ;;
1066 "IPFIRE: Watch Build")
1067 $0 watch
1068 ;;
1069 "IPFIRE: Batch")
1070 $0 batch
1071 ;;
1072 "IPFIRE: Clean")
1073 $0 clean
1074 ;;
1075 "Help")
1076 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1077 cat doc/make.sh-usage
1078 ;;
1079 "LOG: Tail")
1080 tail -f log/_*
1081 ;;
1082 "Exit")
1083 break
1084 ;;
1085 esac
1086 done
1087 ;;
1088 config)
1089 make_config
1090 ;;
1091 *)
1092 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1093 cat doc/make.sh-usage
1094 ;;
1095 esac